import cv2
from ocrpackage import f_utils
from retinaface import RetinaFace
import numpy as np
from ocrpackage.f_orientation_detection import detect_face_orientation


# instaciar detectores
profile_detector         = detect_face_orientation()

def detect_liveness(im):
    
    gray = gray = cv2.cvtColor(im, cv2.COLOR_BGR2GRAY)

    # face detection
    boxes_face = RetinaFace.detect_faces(im)
    # rectangles = frontal_face_detector(gray, 0)
    # boxes_face = f_utils.convert_rectangles2array(rectangles,im)
    if boxes_face:
        # use only the biggest face
        areas = f_utils.get_areas([face["facial_area"] for face in boxes_face.values()])
        index = np.argmax(areas)
        largest_face = list(boxes_face.values())[index]["facial_area"]
        boxes_face = [list(largest_face)]

    # -------------------------------------- profile_detection ---------------------------------------
    '''
    input:
        - imagen gray
    output:
        - status: "ok"
        - profile: ["right"] or ["left"]
        - box: [[579, 170, 693, 284]]
    '''
    box_orientation, orientation = profile_detector.face_orientation(gray)

    # -------------------------------------- output ---------------------------------------
    output = {
        'box_face_frontal': boxes_face,
        'box_orientation': box_orientation,
        'orientation': orientation,
    }
    return output

